/*
 * Copyright (c) 1997 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef utmfunc_h
#define utmfunc_h

#include <ComUnidraw/unifunc.h>
#include <projects.h>

class ComTerp;
class Editor;

class UtmFunc : public UnidrawFunc {
public:
    UtmFunc(ComTerp*, Editor*);
    virtual void execute() = 0;

    static float heading(float dx, float dy);
};

class VhclViewFunc : public UtmFunc {
public:
    VhclViewFunc(ComTerp*, Editor*);
    virtual void execute();

protected:
    int _gr_symid;
    int _name_symid;
    int _vhclpict_symid;
};

class VhclMoveToFunc : public UtmFunc {
public:
    VhclMoveToFunc(ComTerp*, Editor*);
    virtual void execute();

protected:
    int _heading_symid;
};

class RteViewFunc : public UtmFunc {
public:
    RteViewFunc(ComTerp*, Editor*);
    virtual void execute();

protected:
    int _name_symid;
    int _rtepict_symid;
};

class MapViewStateFunc : public UtmFunc {
public:
    MapViewStateFunc(ComTerp*, Editor*);
    virtual void execute();

};

#endif
